import com.vividsolutions.jump.workbench.plugin.AbstractPlugIn;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.*;
import com.vividsolutions.jump.feature.*;
import com.vividsolutions.jts.geom.*;
import java.util.*;
import javax.swing.JComboBox;

import com.vividsolutions.jump.workbench.ui.*;
import com.vividsolutions.jump.workbench.model.*;

//Plugin, kter hled nejbliho souseda k vybranmu bodu
//V OJ Mus bt vrstva obc na prvnm mst (na indexu 0) a vybrn jeden prvek, ke ktermu chceme hledat souseda

public class SousedPlugIn extends AbstractPlugIn {
        
  public void initialize(PlugInContext context){
        context.getFeatureInstaller().addMainMenuItem(this, new String[] { "Nstoje", "Soused" }, "Hledej Souseda", false, null, null);
  }
    
    public boolean execute(PlugInContext context) throws Exception {   
        double dist = 0;   //deklarace promnn do kter si budeme ukldat vzdlenost mezi body
        String name = "";  //deklarace promnn do kter si budeme ukldat nzev nejbliho bodu
        
        Layer itemLayer = context.getWorkbenchContext().getLayerManager().getLayer(0); //nati objekt Layer do promnn Layer -- takto s Layer nebudeme moci manipulovat
        Collection selFeatures = (Collection)((SelectionManagerProxy)context.getActiveInternalFrame()).getSelectionManager().getFeaturesWithSelectedItems(itemLayer); //Nati kolekci vybrannch prvk do promnn selFeatures
        FeatureCollection features = context.getWorkbenchContext().getLayerManager().getLayer(0).getFeatureCollectionWrapper().getWrappee(); //nati objekt Layer do promnn features -- takto meme Layer mnit
        
        if (selFeatures.size()==0){      // testuj jak je velikost kontejneru selFeatures = kolik je pomoc selekce vybrno prvk; pokud dn --> zobraz dialogov okno s textem "Nebyla vybrana zadna polozka, ..."
            MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
            dialog.addLabel("Nebyla vybrana zadna polozka, vyber 1 prvek");
            GUIUtil.centreOnWindow(dialog);
            dialog.setVisible(true);
           }
        else if (selFeatures.size()>1){  //testuj jak je velikost kontejneru selFeatures = kolik je pomoc selekce vybrno prvk; pokud vce ne 1 --> zobraz dialogov okno s textem "Bylo vybrano vice polozek, ..."
            MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
            dialog.addLabel("Bylo vybrano vice polozek, vyber pouze 1 prvek");
            GUIUtil.centreOnWindow(dialog);
            dialog.setVisible(true);
           }
        
       else { // v ostatnch ppadech = kdy je vybrn pouze jeden prvek, prove:
           Iterator it = selFeatures.iterator();      //vytvo itertor it nad kontejnerem selFeatures 
           Feature selFeature = (Feature)it.next();   //do promnn selFeature ulo prvn (vce jich tam ani nen) Feature z kontejneru selFeatures, zskme ho pomoc metody next() --> musme provst petypovn pomoc (Feature) z Object na Feature
           Coordinate A = selFeature.getGeometry().getCoordinate(); //do promnn A typu Coordinate ulo souadnice prvku uloenho v selF; nejdve zskme jeho geometrii pomoc metody getGeometry() a potom souadnice pomoc getCoordinate()
           
           for (Iterator i =features.iterator();i.hasNext();){  //cyklus kter fomoc itertoru prochz FeatureCollection features a hled v n nejbliho souseda k Feature uloen v selFature
               Feature f = (Feature)i.next();                   //do promnn f postupn v kadm prchodu cyklem ukld aktuln prvek
               Coordinate B = f.getGeometry().getCoordinate();  //do promnn B ulo souadnice aktulnho prvku
               double newDist = distance (A,B);                 //spot vzdlenost mezi aktulnm prvkem (f) a vybranm prvkem(selFeature) pomoc metody distance(Coordinate A, Coordinate B), kter je naprogramovan na konci pluginu a ulo ji do promnn newDist
               if (dist == 0 && newDist !=0) dist=newDist;      //podmnky testujc vzdlenosti pokud je star vzdlenost(dist) rovna 0 a nov nen rovna 0 (newDist) pak: dist=newDist ;tm oetme prvn prchod cyklem 
                                                                //newDist !=0 je tam pro vylouen ppadu, kdy cyklus naraz na vybran bod a vzdlenost je tedy nulov, pokud by tam tato podmnka nebyla tvoil by vybran bod nejbliho souseda sm sob
               if ( dist >= newDist && newDist !=0){            //podmnky testujc vzdlenosti pokud je star vzdlenost(dist) rovna vt ne nov (newDist) pak: dist=newDist 
                   dist=newDist;
                   name = (String)f.getAttribute("NAZOB");      //ulo jmno aktuln nejbliho prvku
                            
               }
        
       }                                                        //konec cyklu
       
            
              //zobraz dialogov okno s textem "..." kter oznm vsledek
            MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
            dialog.addLabel("Nejblizsim soudem obce" + selFeature.getAttribute ("NAZOB")+ "je obec" + name + "ve vzdalenosti" + dist);
            GUIUtil.centreOnWindow(dialog);
            dialog.setVisible(true);
       
       
       
       
    }
    
     return true; //vra true
  }
    
  
  // metoda pro vpoet vzdlenosti mezi 2 body; vzdlenost potme ze souadnic pomoc pythagorovy vty
  private double distance(Coordinate A, Coordinate B) throws Exception {
        return Math.sqrt (((A.x-B.x)*(A.x-B.x)) + ((A.y-B.y)*(A.y-B.y)));
   }
        
}  